//******************************************************************************************
//* Magnetic Field of a Solenoid, copyright by Paul Nylander, bugman123.com, 5/17/06
//* 2016-01-01 20:01:23 , ļ㷽ʽ, ʹ, 
//******************************************************************************************

#declare TwoPi=2*pi;
#declare n=6;           // ߹Ȧ
#declare R=0.02;        // ߹ܰ뾶
#declare h=(4/3)*R;     // ߹ݾ
#declare r=R/4;         // ߰뾶
#declare dt=0.002*TwoPi; // ߹ܾܶ
#declare w=0.05;        // ֵ߿

camera{
	location <13.65,0,16.25>*R
	look_at 0.4*R*x
	up  -y
	sky -y
	angle 25
	right x*image_width/image_height
}

light_source{ <0,0,8>*R,2 }

#include "golds.inc"

// ߹X, x0Ϊʼֵ
#declare x0=(n-1)*h/2;
#declare tht0=pi/2;
#declare b=h/TwoPi;
#declare Ntht=(n*TwoPi-2*tht0)/dt;

#local i=0;
#for(i,0,Ntht,1)
	#local tht=i*dt-tht0;
	#local p2=<b*tht-x0, -R*sin(tht), R*cos(tht)>;
	sphere{p2,r texture{T_Gold_1E}}
	#if(i!=0)
		cylinder{p1,p2,r texture{T_Gold_1E}}    
	#end
	#local p1=p2;
#end

// XYƽÿӴĵ, Ϊ1, żΪ-1
#declare I=function(j) { mod(j,2)-1+max(0,mod(j,2)) };
// XYƽڽӴ 
#declare xi=function(j) { b*(j-3/2)*pi-x0 };
#declare yi=function(j) { I(j)*R }; 
// ųǿ, B^2=Bx^2+By^2, Լλ
#declare B=function{ 2*n*R*R * sqrt(
	pow( sum( j,1,2*n, I(j)*(y-yi(j)) / (pow((x-xi(j)),2)+pow((y-yi(j)),2)) ),2 )
  + pow( sum( j,1,2*n, I(j)*(x-xi(j)) / (pow((x-xi(j)),2)+pow((y-yi(j)),2)) ),2 )
)}
// ֵ
#declare contours=function{ 1/2+1/2*cos(w*TwoPi*sum(j,1,2*n, I(j)/sqrt(pow((x-xi(j)),2)+pow((y-yi(j)),2)) )) }

#declare xj=function(j) {  b*(j*dt-tht0)-x0 }
#declare yj=function(j) { -R*sin(j*dt-tht0) }
#declare zj=function(j) {  R*cos(j*dt-tht0) }
#declare rcub=function(x,y,z,j) { pow(pow(x-xj(j),2)+pow(y-yj(j),2)+pow(z-zj(j),2), 1.5) }

#declare Bx=function{ sum(j,0,Ntht, (-zj(j)*(z-zj(j))-yj(j)*(y-yj(j)))/rcub(x,y,z,j) ) }
#declare By=function{ sum(j,0,Ntht, (-b    *(z-zj(j))+yj(j)*(x-xj(j)))/rcub(x,y,z,j) ) }
#declare Bz=function{ sum(j,0,Ntht, ( b    *(y-yj(j))+zj(j)*(x-xj(j)))/rcub(x,y,z,j) ) }
#declare Btot=function{ R*dt/TwoPi * sqrt( pow(Bx(x,y,z),2)+pow(By(x,y,z),2)+pow(Bz(x,y,z),2) ) }
#declare Bcon=function{ 1/2+1/2*cos(w*TwoPi* dt/sqrt(R*R+b*b) * sum(j,0,Ntht, yj(j)/sqrt(pow((x-xj(j)),2)+pow((y-yj(j)),2)+pow(z-zj(j),2)) )) }

plane{
	<0,0,1>, 0
	pigment{    
		//function{ min(B(x,y,0),1)*contours(x,y,0) } // Ӵ
		function{ min(Btot(x,y,0),1)*Bcon(x,y,0) } // ޳߹
		color_map{ [0 rgbt <0,0,1,1>] [0.25 rgbt <0,0,1,0.75>] [0.5 rgbt <1/3,0,1,0.5>] [0.75 rgbt <2/3,0.5,1,0.25>] [1 rgbt <1,1,1,0>] }
	}
	finish{ ambient 2.25 reflection 0 diffuse 0 specular 0 }
}